#ifndef win32text_h
#define win32text_h

/* Important: this must match the default_text list in win32text.c! */
enum
{
	WIN32_first_entry = -1,

	/* icon explanation */
	WIN32_icon_togglefolderlist,
	WIN32_icon_togglescreenshot,
	WIN32_icon_largeicons,
	WIN32_icon_smallicons,
	WIN32_icon_list,
	WIN32_icon_details,
#ifndef BUILD_ENGLISH
	WIN32_icon_japaneselist,
#endif
	WIN32_icon_The_position,
#ifdef KAILLERA
#ifndef BUILD_ENGLISH
	WIN32_icon_useIME,
#endif
	WIN32_icon_usefixedform,
#endif
	WIN32_icon_about,
	WIN32_icon_invalidbutton,

	/* old control warning */
	WIN32_oldcontrol01,
	WIN32_oldcontrol02,
	WIN32_oldcontrol03,
	WIN32_oldcontrol04,
	WIN32_oldcontrol05,
	WIN32_oldcontrol06,
	WIN32_oldcontrol07,
	WIN32_oldcontrol_title,

	/* list view column */
	WIN32_columntext_game,
	WIN32_columntext_directory,
	WIN32_columntext_trackball,
	WIN32_columntext_played,
	WIN32_columntext_manufacturer,
	WIN32_columntext_year,
	WIN32_columntext_genre,
	WIN32_columntext_cloneof,

	/* game genre */
	WIN32_genre_action,
	WIN32_genre_shoot,
	WIN32_genre_fight,
	WIN32_genre_race,
	WIN32_genre_sports,
	WIN32_genre_puzzle,
	WIN32_genre_table,
	WIN32_genre_quiz,
#ifndef BUILD_ENGLISH
	WIN32_genreeng_action,
	WIN32_genreeng_shoot,
	WIN32_genreeng_fight,
	WIN32_genreeng_race,
	WIN32_genreeng_sports,
	WIN32_genreeng_puzzle,
	WIN32_genreeng_table,
	WIN32_genreeng_quiz,
#endif

	/* progress bar */
	WIN32_progressbar_MMX,
	WIN32_progressbar_games,
	WIN32_progressbar_imperfectcolors,
	WIN32_progressbar_gamesearch,
	WIN32_progressbar_complete,

	/* status bar */
	WIN32_statusbar_ready,
	WIN32_statusbar_games,

	/* menu bar */
	WIN32_menubar_disableplay,
	WIN32_menubar_enableplay,

	/* command line */
	WIN32_commandline_nogame,
	WIN32_commandline_nogametitle,
	WIN32_commandline_noreso,
	WIN32_commandline_noresotitle,
	WIN32_commandline_unknown,
	WIN32_commandline_unknowntitle,

	/* about NMAME X II */
	WIN32_about01,
	WIN32_about02,
	WIN32_about03,
	WIN32_about04,
	WIN32_about05,
	WIN32_about06,
	WIN32_about07,
	WIN32_about08,
	WIN32_about09,
	WIN32_about10,
	WIN32_about11,
	WIN32_about12,
	WIN32_about13,
	WIN32_about14,
	WIN32_about15,
	WIN32_about16,
	WIN32_about17,
	WIN32_about18,
	WIN32_about19,
	WIN32_about20,
	WIN32_about21,
	WIN32_about22,
	WIN32_about23,
	WIN32_about24,
	WIN32_about25,
	WIN32_about26,
	WIN32_about27,
	WIN32_about28,
	WIN32_about29,
	WIN32_about30,
	WIN32_about31,
	WIN32_about32,
	WIN32_about33,
	WIN32_about34,
	WIN32_about35,
	WIN32_about36,
	WIN32_about37,
	WIN32_about38,
	WIN32_about39,
	WIN32_about40,
	WIN32_about41,
	WIN32_about42,
	WIN32_about43,
	WIN32_about44,
	WIN32_about45,
	WIN32_about46,
	WIN32_about47,
	WIN32_about48,
	WIN32_about49,
	WIN32_about50,
	WIN32_about51,
	WIN32_about52,
	WIN32_about53,
	WIN32_about54,

	/* DirectX help */
	WIN32_directxhelp01,
	WIN32_directxhelp02,
	WIN32_directxhelp03,
	WIN32_directxhelp04,

	/* NMAME X II help */
	WIN32_help01,
	WIN32_help02,
	WIN32_help03,
	WIN32_help04,
	WIN32_help05,
	WIN32_help06,
	WIN32_help07,
	WIN32_help08,

	/* recording relation */
	WIN32_record_validinp,
	WIN32_record_validinptitle,
	WIN32_record_inpzipfile,
	WIN32_record_inpfile,
	WIN32_record_avifile,

	/* loading roms */
	WIN32_loading,

	/* rom list */
	WIN32_romlist_byte,

	/* DirectX error code */
	WIN32_errorcode,
	WIN32_ddraw_notinitialized,
	WIN32_dinput_notinitialized,

	/* Avi.c */
	WIN32_avi_reflectionFPS,
	WIN32_avi_reflectionFPStitle,

	/* ColumnEdit.c */
	WIN32_column_cantmoveitem,
	WIN32_column_moveitem,
	WIN32_column_selectnopermit,
	WIN32_column_selectitem,

	/* DDrawDisplay.c */
	WIN32_ddraw_not16bppsupport,
	WIN32_ddraw_notwork8bit,
	WIN32_ddraw_restoreerrorcode,

	/* DirectDraw.c */
	WIN32_ddraw_dllnotfound,
	WIN32_ddraw_ddcexnotfound,

	/* DirectInput.c */
	WIN32_dinput_dllnotfound,
	WIN32_dinput_dicexnotfound,

	/* DirectSound.c */
	WIN32_dsound_dllnotfound,
	WIN32_dsound_dscnotfound,

	/* Directories.c */
	WIN32_dir_roms,
	WIN32_dir_config,
	WIN32_dir_snapshots,
	WIN32_dir_icons,
	WIN32_dir_inputfiles,
	WIN32_dir_state,
	WIN32_dir_memorycard,
	WIN32_dir_flyers,
	WIN32_dir_cabinets,
	WIN32_dir_marquees,
	WIN32_dir_nvram,
	WIN32_dir_combo,
	WIN32_dir_wave,
	WIN32_dir_notfound,
	WIN32_dir_notfoundtitle,
	WIN32_dir_foldername,

	/* M32Util.c */
	WIN32_utility_outofmemory,
	WIN32_utility_notfound,
	WIN32_utility_noassoc,
	WIN32_utility_oom,
	WIN32_utility_pnf,
	WIN32_utility_share,
	WIN32_utility_unknown,

	/* Properties.c */
	WIN32_property_defaultgame,
	WIN32_property_sheeterror,
	WIN32_property_sheeterrortitle,
	WIN32_property_sound,
	WIN32_property_colors,
	WIN32_property_rommissing,
	WIN32_property_notworking,
	WIN32_property_colorwrong,
	WIN32_property_imperfectcolor,
	WIN32_property_working,
	WIN32_property_unknown,
	WIN32_property_globaloptions,
	WIN32_property_autosize,
	WIN32_property_nosound,
	WIN32_property_midas,
	WIN32_property_directsound,
	WIN32_property_primarydisplay,
	WIN32_property_x1,
	WIN32_property_x2slow,
	WIN32_property_x2blitfast,
	WIN32_property_x2blitfastest,
	WIN32_property_x3blit,
	WIN32_property_x4blit,
	WIN32_property_scan,
	WIN32_property_scanblit,
	WIN32_property_stretchblit,
	WIN32_property_autoframeskip,
	WIN32_property_everyframe,
	WIN32_property_frameskip,
	WIN32_property_normal,
	WIN32_property_hotrod,
	WIN32_property_hotrodse,
	WIN32_property_ASMcore,
	WIN32_property_Ccore,
	WIN32_property_standarddriver,
	WIN32_property_rasterdriver,
	WIN32_property_standardBIOS,
	WIN32_property_debugBIOS,

	/* TreeView.c */
	WIN32_folder_allgames,
	WIN32_folder_available,
#if defined(LMR)
	WIN32_folder_unavailable,
#endif
	WIN32_folder_manufacturer,
	WIN32_folder_year,
	WIN32_folder_genre,
	WIN32_folder_working,
	WIN32_folder_nonworking,
	WIN32_folder_custom,
	WIN32_folder_played,
	WIN32_folder_favorite,
	WIN32_folder_original,
	WIN32_folder_clones,
	WIN32_folder_trackball,
	WIN32_reset01,
	WIN32_reset02,
	WIN32_reset03,
	WIN32_reset04,
	WIN32_reset05,
	WIN32_resettitle,

	/* audit32.c */
	WIN32_audit_checkgame,
	WIN32_audit_fileaudit,
	WIN32_audit_pause,
	WIN32_audit_continue,
	WIN32_audit_complete,
	WIN32_audit_close,
	WIN32_audit_nonerequired,
	WIN32_audit_passed,
	WIN32_audit_bestavailable,
	WIN32_audit_notfound,
	WIN32_audit_failed,

	/* file.c */
	WIN32_file_errorwriting_cfg,
	WIN32_file_errorwriting_nv,

	/* mzip.c */
	WIN32_zipwarning01,
	WIN32_zipwarning02,
	WIN32_zipwarning03,
	WIN32_zipwarning04,
	WIN32_zipwarning05,
	WIN32_zipwarning06,
	WIN32_zipwarning07,
	WIN32_zipwarningtitle,

	/* options.c */
	WIN32_options_oldinfo01,
	WIN32_options_oldinfo02,
	WIN32_options_oldinfo03,
	WIN32_options_oldinfo04,
	WIN32_options_oldinfo05,
	WIN32_options_oldinfotitle,

	WIN32_last_entry
};

const char *win32_getstring (int string_num);
void connect_strings (char *buf, int string_num_start, int string_num_end);

#endif

