#ifndef M68000__HEADER
#define M68000__HEADER

#include "osd_cpu.h"
#include "mamedbg.h"
#include "m68k.h"

#if 0
enum {
	M68K_PC=1, M68K_ISP, M68K_USP, M68K_SR, M68K_VBR, M68K_SFC, M68K_DFC,
	M68K_D0, M68K_D1, M68K_D2, M68K_D3, M68K_D4, M68K_D5, M68K_D6, M68K_D7,
	M68K_A0, M68K_A1, M68K_A2, M68K_A3, M68K_A4, M68K_A5, M68K_A6, M68K_A7
};
#else
enum
{
	/* NOTE: M68K_SP fetches the current SP, be it USP, ISP, or MSP */
	M68K_PC=1, M68K_SP, M68K_ISP, M68K_USP, M68K_MSP, M68K_SR, M68K_VBR,
	M68K_SFC, M68K_DFC, M68K_CACR, M68K_CAAR, M68K_PREF_ADDR, M68K_PREF_DATA,
	M68K_D0, M68K_D1, M68K_D2, M68K_D3, M68K_D4, M68K_D5, M68K_D6, M68K_D7,
	M68K_A0, M68K_A1, M68K_A2, M68K_A3, M68K_A4, M68K_A5, M68K_A6, M68K_A7
};
#endif

/* The MAME API for MC68000 */

#define MC68000_INT_NONE 0
#define MC68000_IRQ_1    1
#define MC68000_IRQ_2    2
#define MC68000_IRQ_3    3
#define MC68000_IRQ_4    4
#define MC68000_IRQ_5    5
#define MC68000_IRQ_6    6
#define MC68000_IRQ_7    7

#define MC68000_INT_ACK_AUTOVECTOR    -1
#define MC68000_INT_ACK_SPURIOUS      -2

extern int m68000_ICount;
extern void m68000_reset(void *param);
extern void m68000_exit(void);
extern int m68000_execute(int cycles);
extern unsigned m68000_get_context(void *dst);
extern void m68000_set_context(void *src);
extern unsigned m68000_get_pc(void);
extern void m68000_set_pc(unsigned val);
extern unsigned m68000_get_sp(void);
extern void m68000_set_sp(unsigned val);
extern unsigned m68000_get_reg(int regnum);
extern void m68000_set_reg(int regnum, unsigned val);
extern void m68000_set_nmi_line(int state);
extern void m68000_set_irq_line(int irqline, int state);
extern void m68000_set_irq_callback(int (*callback)(int irqline));
extern const char *m68000_info(void *context, int regnum);
extern unsigned m68000_dasm(char *buffer, unsigned pc);

extern int m68000c_ICount;
extern void m68000c_reset(void *param);
extern void m68000c_exit(void);
extern int m68000c_execute(int cycles);
extern unsigned m68000c_get_context(void *dst);
extern void m68000c_set_context(void *src);
extern unsigned m68000c_get_pc(void);
extern void m68000c_set_pc(unsigned val);
extern unsigned m68000c_get_sp(void);
extern void m68000c_set_sp(unsigned val);
extern unsigned m68000c_get_reg(int regnum);
extern void m68000c_set_reg(int regnum, unsigned val);
extern void m68000c_set_nmi_line(int state);
extern void m68000c_set_irq_line(int irqline, int state);
extern void m68000c_set_irq_callback(int (*callback)(int irqline));
extern const char *m68000c_info(void *context, int regnum);
extern unsigned m68000c_dasm(char *buffer, unsigned pc);

#endif /* M68000__HEADER */
