/*****************************************************************************

  ui_font.c

  NMAME X IIœ{ꕶ֐񋟂܂B

*****************************************************************************/

#include "driver.h"
#ifdef KAILLERA
#include "KailleraChat.h"
#endif

static UINT16 _uifonttable[65536];

static unsigned char fontwidth12x12p[] =
{
#include "font\z16x12pw.dat"
};

/****************************************************************************
 static UINT16 uifont_buildtable(UINT16 code)

 tHgf[^e[u쐬܂B
*****************************************************************************/

static UINT16 uifont_buildtable(UINT16 code)
{
	UINT8 c1, c2;

	c1 = (code >> 8) & 0xff;
	c2 = code & 0xff;

	if (code >= 0x8140 && code <= 0x9ffc)
	{
		code = ((c1 - 0x81) << 8) + (c2 - 0x40);
	}
	else if (code >= 0xe040 && code <= 0xfcfc)
	{
		code = ((c1 - 0xe0 + (0xa0 - 0x81)) << 8) + (c2 - 0x40);
	}
	else
		return 0x60;

	return (code - ((code >> 8) & 0xff) * 0x40);
}


/****************************************************************************
 unsigned short get_uifont_code(char *s)

 s̍ŏ̃̕tHgf[^ԍԂ܂B
*****************************************************************************/

unsigned short get_uifont_code(const char *s)
{
	unsigned short code;
	unsigned char *c = (unsigned char *)s;

	code = (*c << 8) | *(c + 1);

	if (code >= 0x8140 && code <= 0x9ffc)
	{
		code = ((*c - 0x81) << 8) + (*(c + 1) - 0x40);
	}
	else if (code >= 0xe040 && code <= 0xfcfc)
	{
		code = ((*c - 0xe0 + (0xa0 - 0x81)) << 8) + (*(c + 1) - 0x40);
	}
	else
		return 0x60;

	return (code - ((code >> 8) & 0xff) * 0x40);
}


/****************************************************************************
 int uifont_buildfont(void)

 tHg쐬܂B
*****************************************************************************/

int uifont_buildfont(void)
{
	static unsigned char fontdata6x12[] =
	{
		#include "font\h8x12.dat"
	};
	static unsigned char fontdata12x12[] =
	{
		#include "font\z16x12.dat"
	};
	static unsigned char fontdata12x12p[] =
	{
		#include "font\z16x12p.dat"
	};
	static struct GfxLayout fontlayout6x12 =
	{
		6,12,	/* 6*12 characters */
		256,    /* 128 characters */
		1,	/* 1 bit per pixel */
		{ 0 },
		{ 0, 1, 2, 3, 4, 5, 6, 7 },	/* straightforward layout */
		{ 0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8, 8*8, 9*8, 10*8, 11*8 },
		8*12	/* every char takes 8 consecutive bytes */
	};
	static struct GfxLayout fontlayout12x12 =
	{
		12,12,
		(0x9fff - 0x8140) + (0xfcff - 0xe040) + 1,
		1,
		{ 0 },
		{ 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15 },
		{ 0*16,1*16,2*16,3*16,4*16,5*16,6*16,7*16,8*16,9*16,10*16,11*16 },
		16*12
	};
	static struct GfxLayout fontlayout12x12p =
	{
		12,12,
		(0x888f - 0x8140) + 1,
		1,
		{ 0 },
		{ 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15 },
		{ 0*16,1*16,2*16,3*16,4*16,5*16,6*16,7*16,8*16,9*16,10*16,11*16 },
		16*12
	};
	static unsigned short colortable[2 * 2];
	int i;

	Machine->uifont   = 0;
	Machine->uifont2  = 0;

	colortable[0] = 0;
	colortable[1] = FONT_COLOR_NORMAL;
	colortable[2] = FONT_COLOR_NORMAL;
	colortable[3] = 0;

	if ((Machine->uifont = decodegfx(fontdata6x12, &fontlayout6x12)))
	{
		Machine->uifont->colortable = colortable;
		Machine->uifont->total_colors = 2;
		Machine->uifontwidth = 6;
		Machine->uifontheight = 12;
	}
	else
		return 0;

	if ((Machine->uifont2 = decodegfx(fontdata12x12, &fontlayout12x12)))
	{
		Machine->uifont2->colortable = colortable;
		Machine->uifont2->total_colors = 2;
		Machine->uifontwidth2 = 12;
		Machine->uifontheight2 =12;
	}
	else
	{
		uifont_freefont();
		return 0;
	}

	if ((Machine->uifont2p = decodegfx(fontdata12x12p, &fontlayout12x12p)))
	{
		Machine->uifont2p->colortable = colortable;
		Machine->uifont2p->total_colors = 2;
		Machine->uifontheight2p =12;
		Machine->uifontwidth2p = 12;
	}
	else
	{
		uifont_freefont();
		return 0;
	}

	for (i = 0x4081; i < 0xfffc; i++)
		_uifonttable[i] = uifont_buildtable(i) + 256;

	return 1;
}


/****************************************************************************
 void uifont_freefont(void)

 tHg܂B
*****************************************************************************/

void uifont_freefont(void)
{
	if (Machine->uifont2)
	{
		freegfx(Machine->uifont2);
		Machine->uifont2 = 0;
	}
	if (Machine->uifont)
	{
		freegfx(Machine->uifont);
		Machine->uifont = 0;
	}
}

/*****************************************************************************
 int get_chartype(char *s)

 s̐擪̕Ԃ܂B
*****************************************************************************/

int get_chartype(const char *s)
{
#ifndef BUILD_ENGLISH
	{
		unsigned char *c = (unsigned char *)s;

		// p
		if (ishkana(*c)) return HKANA;

		// Sp̑1oCg
		if (iszen1(*c) && iszen2(*(c + 1))) return ZKANJI;
	}
#endif

	// LȊOASCIIR[h
	return ASCII;
}

/****************************************************************************
 int get_fontwidth(int code, int fonttype)

 codẽtHgf[^̕Ԃ܂B
*****************************************************************************/

int get_fontwidth(int code, int fonttype)
{
	int width;

	if ((fonttype & FONT_PROPORTIONAL) && code < PFONT_END)
		width = fontwidth12x12p[code];
	else
		width = Machine->uifontwidth2;

	if (fonttype & FONT_BOLD)
		width++;

	return width;
}

#define ISSJIS1(c) ((c >= 0x81 && c <= 0x9f) || (c >= 0xe0 && c <= 0xfc))
#define ISSJIS2(c) ((c >= 0x40 && c <= 0xfc) && (c != 0x7f))

int uifont_decodechar(unsigned char *s, unsigned short *code)
{
    unsigned char c1 = *(unsigned char *)s;
    unsigned char c2 = *(unsigned char *)(s + 1);

    if (ISSJIS1(c1) && ISSJIS2(c2))
    {
        *code = _uifonttable[(c1 << 8) | c2];

        if (*code == 0)
            *code = _uifonttable[0x817f];

        return 2;
    }

    *code = c1;
    return 1;
}

#undef ISSJIS1
#undef ISSJIS2


/****************************************************************************
 int strwidth(char *s, int fonttype)

 s̕`ɕKvȕԂ܂B
*****************************************************************************/

int strwidth(const char *s, int fonttype)
{
	int width = 0, n = 0, ct;

	while (s[n])
	{
		ct = get_chartype(&s[n]);

		if (ct == ZKANJI)
		{
			UINT16 code = get_uifont_code(&s[n]);
			width += get_fontwidth(code, fonttype);
			n += 2;
		}
		else
		{
			width += Machine->uifontwidth + ((fonttype & FONT_BOLD) != 0);
			n++;
		}
	}

	return width;
}


/*****************************************************************************
 void uifont_drawfont(const char *s, int sx, int sy, int color, int drawmode, int fonttype)

 EShift-JISR[h܂ޕAbitmap֕`悵܂B

 <>

  char *s       : 

  int sx        : `Jn鉡W

  int sy        : `JncW

  int color     : `悷J[e[u
                   UI_COLOR_NORMAL  𔒁Awi܂͓/F
                   UI_COLOR_INVERSE 𓧉/FAwi

  int fontcolor : TRANSPARENCY_FONT/FONT2ŕ`悷Fw肵܂

  int drawmode  : `惂[hw肵܂
                   TRANSPARENCY_NONE  tHgf[^̂܂ܕ`
                   TRANSPARENCY_FONT  wi𓧉߂ĕ`
                   TRANSPARENCY_FONT2 wi𔼓Fŕ`

  int fonttype  : tHg̎ނw肵܂
                   FONT_NORMAL        tHg
                   FONT_PROPORTIONAL  v|[VitHg
                   FONT_BOLD          (̓ƍ킹Ďgp)
                                       ) FONT_PROPORTIONAL|FONT_BOLD

*****************************************************************************/

int uifont_drawfont(struct osd_bitmap *bitmap, const char *s, int sx,
                    int sy, int color, int fontcolor, int drawmode, int fonttype)
{
    int x, y, ct = 0, wrapped, next_sy, increment;
#ifdef BUILD_ENGLISH
	int button = 0;
#endif
    unsigned short code;
    unsigned char *c;
    struct GfxElement *uifont;

    c      = (unsigned char *)s;
    x      = sx;
    y      = sy;
    code   = 0;
    next_sy = 0;

    while (*c)
    {
        wrapped = 0;

        increment = uifont_decodechar(c, &code);

        if (*c == '\n')
        {
            x = sx;
            y += Machine->uifontheight + 1;
            next_sy += Machine->uifontheight;
            c++;
            continue;
        }
        else
        {
			ct = get_chartype((const char *)c);

#ifdef BUILD_ENGLISH
			if (x + Machine->uifontwidth + ((fonttype & FONT_BOLD) != 0) > Machine->uiwidth)
			{
				x = sx;
				y += Machine->uifontheight + 1;
				next_sy += Machine->uifontheight;
				wrapped = 1;
			}
#endif
		}

        if (y >= Machine->uiheight)
            return next_sy;

        if (!wrapped)
        {
			int col = fontcolor;
//			struct rectangle *myclip = 0, myclip2 = {0, 0, 0, 0};

			if (ct == ZKANJI)
			{
				if ((fonttype & FONT_PROPORTIONAL) && code < PFONT_END)
				{
					uifont = Machine->uifont2p;
#if 0
					if (drawmode == TRANSPARENCY_FONT2)
					{
						myclip2.min_x = x + Machine->uixmin;
						myclip2.max_x = x + Machine->uixmin + get_fontwidth(code, fonttype) + ((fonttype & FONT_BOLD) ? 0 : -1);
						myclip2.min_y = y + Machine->uiymin;
						myclip2.max_y = y + Machine->uiymin + Machine->uifontheight - 1;
						myclip = &myclip2;
					}
#endif
				}
				else
					uifont = Machine->uifont2;

#ifndef BUILD_ENGLISH
				if (code > 0x00ff)
	            {
	                code -= 256;

	                if (code == 0x0080)      col = BUTTON_COLOR_RED;
	                else if (code == 0x0081) col = BUTTON_COLOR_YELLOW;
	                else if (code == 0x0082) col = BUTTON_COLOR_GREEN;
	                else if (code == 0x0083) col = BUTTON_COLOR_BLUE;

					if (col != FONT_COLOR_NORMAL)
	                {
	                    Machine->uifont->colortable[1] = col;
	                    Machine->uifont->colortable[2] = col;
	                }
	            }
#endif
			}
			else
			{
				uifont = Machine->uifont;
			}

#ifdef BUILD_ENGLISH
			if (code > 0x00ff)
            {
                code -= 256;
				button = 1;

                if (code == 0x0080)      col = BUTTON_COLOR_RED;
                else if (code == 0x0081) col = BUTTON_COLOR_YELLOW;
                else if (code == 0x0082) col = BUTTON_COLOR_GREEN;
                else if (code == 0x0083) col = BUTTON_COLOR_BLUE;

				if (col != FONT_COLOR_NORMAL)
                {
                    Machine->uifont->colortable[1] = col;
                    Machine->uifont->colortable[2] = col;
                }
				uifont = Machine->uifont2;
            }
#endif

			if (fonttype & FONT_BOLD)
			{
				drawgfx(bitmap,
					uifont,
					code,
					color,
					0,
					0,
					x + Machine->uixmin + 1,
					y + Machine->uiymin,
					0, // myclip,
					drawmode,
					col);
			}

           drawgfx(bitmap,
                uifont,
                code,
                color,
                0,
                0,
                x + Machine->uixmin,
                y + Machine->uiymin,
				0, // myclip,
                drawmode,
                col);

            if (col != FONT_COLOR_NORMAL)
            {
                Machine->uifont->colortable[1] = FONT_COLOR_NORMAL;
                Machine->uifont->colortable[2] = FONT_COLOR_NORMAL;
            }

			if (ct == ZKANJI)	x += get_fontwidth(code, fonttype);
#ifdef BUILD_ENGLISH
			else if (button)
			{
				x += Machine->uifontwidth2;
				button = 0;
			}
#endif
			else	x += Machine->uifontwidth;

            while (increment)
            {
                c++;
                increment--;
            }
        }
    }

    return next_sy;
}
