#ifndef ui_text_h
#define ui_text_h

#define MAX_KEY_LEN   31
#define MAX_PORT_LEN  63

/* Important: this must match the default_text list in ui_text.c! */
enum
{
	UI_first_entry = -1,

	UI_mame,

	/* copyright stuff */
	UI_copyright1,
	UI_copyright2,
	UI_copyright3,

	/* misc menu stuff */
	UI_returntomain,
	UI_returntoprior,
	UI_anykey,
	UI_selectkey,
	UI_on,
	UI_off,
	UI_NA,
	UI_OK,	// test code
	UI_INVALID,
	UI_none,
	UI_cpu,
	UI_address,
	UI_value,
	UI_sound,
	UI_sound_lc, /* lower-case version */
	UI_stereo,
	UI_vectorgame,
	UI_screenres,
	UI_text,
	UI_volume,
	UI_relative,
	UI_allchannels,
	UI_brightness,
	UI_gamma,
	UI_vectorintensity,
	UI_overclock,
	UI_allcpus,
	UI_transparency,
	UI_historymissing,
	UI_commandmissing,

	/* special characters */
	UI_leftarrow,
	UI_rightarrow,
	UI_uparrow,
	UI_downarrow,
	UI_lefthilight,
	UI_righthilight,

	/* main menu */
	UI_inputgeneral,
	UI_dipswitches,
	UI_analogcontrols,
	UI_calibrate,
	UI_bookkeeping,
	UI_inputspecific,
	UI_gameinfo,
	UI_history,
	UI_command,
	UI_resetgame,
	UI_returntogame,
	UI_cheat,
	UI_memorycard,
	UI_custombuttons,
	UI_autofiredelay,

	/* input stuff */
	UI_keyjoyspeed,
	UI_reverse,
	UI_sensitivity,

	/* stats */
	UI_tickets,
	UI_coin,
	UI_locked,

	/* memory card */
	UI_loadcard,
	UI_ejectcard,
	UI_createcard,
	UI_resetcard,
	UI_loadfailed,
	UI_loadok,
	UI_cardejected,
	UI_cardcreated,
	UI_cardcreatedfailed,
	UI_cardcreatedfailed2,
	UI_carderror,

	/* cheat stuff */
	UI_watchpoint,
	UI_cheats,
	UI_watchpoints,
	UI_moreinfo,
	UI_moreinfoheader,
	UI_set,
	UI_conflict_found,
	UI_search_select_value,	// test code

	/* custom button */
	UI_custombutton,
	UI_custombutton_combo,
	UI_custombutton_notuse,
	UI_autofire_button,
	UI_autofire_delay,
	UI_custombutton_AB,
	UI_custombutton_AC,
	UI_custombutton_AD,
	UI_custombutton_BC,
	UI_custombutton_BD,
	UI_custombutton_CD,
	UI_custombutton_ABC,
	UI_custombutton_ABD,
	UI_custombutton_BCD,
	UI_custombutton_ABCD,
	UI_autofire_A,
	UI_autofire_B,
	UI_autofire_C,
	UI_autofire_D,

	/* save/load state stuff */
	UI_savestate,
	UI_loadstate,
	UI_date,
	UI_time,
	UI_stateinfo,
	UI_savestateok,
	UI_loadstateok,

	/* save/load combo stuff */
	UI_savecombo,
	UI_loadcombo,
	UI_savecombook,
	UI_loadcombook,
	UI_startrecordcombo,

	/* WAVE recording */
	UI_waverecording,

	/* Juke Box */
	UI_jukebox,
	UI_bank,
	UI_code1,
	UI_code2,
	UI_jukecommand,
	UI_jukeplay,
	UI_jukestop,
	UI_jukerecord,
	UI_jukestop_exp,
	UI_jukerecord_exp,
	UI_jukecode_exp,
	UI_jukefadeout_exp,
	UI_jukerandomstop_exp,
	UI_jukenext_exp,
	UI_jukestop_exp2,
	UI_jukerecord_exp2,
	UI_jukecode_exp2,
	UI_jukefadeout_exp2,
	UI_fadeouttimer,
	UI_fadeoutsecond,
	UI_gotorandomplay,
	UI_gotoplaylist,
	UI_gotomanualcode,
	UI_bgm,
	UI_se1,
	UI_se2,
	UI_se3,
	UI_se4,
	UI_se5,
	UI_se6,
	UI_se7,

	/* object operation */
	UI_object_operation,
	UI_object_number,
	UI_object_exp,
	UI_frontlayer,
	UI_altbackcolor,
	UI_object_clear,
	UI_object_def,
	UI_object_off,
	UI_object_on,

	/* audit.c */
	UI_bytes,
	UI_auditwronglength,
	UI_auditbaddump,
	UI_auditneedredump,
	UI_auditwrongcrc,
	UI_auditnotfound,
	UI_auditgood,
	UI_auditmemerror,

	/* inptport.c */
	UI_emptyslot,
	UI_combononame,

	/* input.c */
	UI_codena,
	UI_codenone,
	UI_codenot,
	UI_codeor,

	/* driver/neogeo.c */
	UI_rastereffects,
	UI_enable,
	UI_disable,

	/* win32/DIJoystick.c */
	UI_dijoy_povname_f,
	UI_dijoy_povname_b,
	UI_dijoy_povname_r,
	UI_dijoy_povname_l,
	UI_dijoy_mousebutton,
	UI_dijoy_joycode_neg,
	UI_dijoy_joycode_pos,
	UI_dijoy_joybutton,
	UI_dijoy_joypov,

	/* win32/Joystick.c */
	UI_joy_axisname_x,
	UI_joy_axisname_y,
	UI_joy_axisname_z,
	UI_joy_axisname_r,
	UI_joy_axisname_u,
	UI_joy_axisname_v,
	UI_joy_povname_f,
	UI_joy_povname_r,
	UI_joy_povname_b,
	UI_joy_povname_l,
	UI_joy_mousebutton,
	UI_joy_joycode_neg,
	UI_joy_joycode_pos,
	UI_joy_joybutton,
	UI_joy_joypov,

	UI_last_entry
};

enum
{
	KEY_first_entry = -1,
	KEY_akey,
	KEY_bkey,
	KEY_ckey,
	KEY_dkey,
	KEY_ekey,
	KEY_fkey,
	KEY_gkey,
	KEY_hkey,
	KEY_ikey,
	KEY_jkey,
	KEY_kkey,
	KEY_lkey,
	KEY_mkey,
	KEY_nkey,
	KEY_okey,
	KEY_pkey,
	KEY_qkey,
	KEY_rkey,
	KEY_skey,
	KEY_tkey,
	KEY_ukey,
	KEY_vkey,
	KEY_wkey,
	KEY_xkey,
	KEY_ykey,
	KEY_zkey,
	KEY_0key,
	KEY_1key,
	KEY_2key,
	KEY_3key,
	KEY_4key,
	KEY_5key,
	KEY_6key,
	KEY_7key,
	KEY_8key,
	KEY_9key,
	KEY_0pad,
	KEY_1pad,
	KEY_2pad,
	KEY_3pad,
	KEY_4pad,
	KEY_5pad,
	KEY_6pad,
	KEY_7pad,
	KEY_8pad,
	KEY_9pad,
	KEY_function1,
	KEY_function2,
	KEY_function3,
	KEY_function4,
	KEY_function5,
	KEY_function6,
	KEY_function7,
	KEY_function8,
	KEY_function9,
	KEY_function10,
	KEY_function11,
	KEY_function12,
	KEY_escape,
	KEY_tilde,
	KEY_minus,
	KEY_equals,
	KEY_backspace,
	KEY_tab,
	KEY_openbrace,
	KEY_closebrace,
	KEY_enter,
	KEY_colon,
	KEY_quote,
	KEY_backslash,
	KEY_comma,
	KEY_stop,
	KEY_slash,
	KEY_space,
	KEY_insert,
	KEY_del,
	KEY_home,
	KEY_end,
	KEY_pageup,
	KEY_pagedown,
	KEY_left,
	KEY_right,
	KEY_up,
	KEY_down,
	KEY_slashpad,
	KEY_asterisk,
	KEY_minuspad,
	KEY_pluspad,
	KEY_delpad,
	KEY_enterpad,
	KEY_printscreen,
	KEY_pause,
	KEY_leftshift,
	KEY_rightshift,
	KEY_leftcontrol,
	KEY_rightcontrol,
	KEY_leftalt,
	KEY_rightalt,
	KEY_shift,
	KEY_ctrl,
	KEY_alt,
	KEY_leftwin,
	KEY_rightwin,
	KEY_menu,
	KEY_scrolllock,
	KEY_numlock,
	KEY_capslock,

	KEY_last_entry
};

enum
{
	PORT_first_entry = -1,

	PORT_ConfigMenu,
	PORT_OnScreenDisplay,
	PORT_SingleStep,
	PORT_Pause,
	PORT_ResetGame,
	PORT_ShowGfx,
	PORT_SaveState,
	PORT_LoadState,
	PORT_SaveCombo,
	PORT_LoadCombo,
	PORT_FrameskipDec,
	PORT_FrameskipInc,
	PORT_Throttole,
	PORT_ShowFPS,
	PORT_ShowProfiler,
	PORT_SaveSnapshot,
	PORT_ToggleCheat,
	PORT_ChangeScreenMode,
	PORT_ShowInputLog,
	PORT_ToggleWaveRecording,
	PORT_SoundTest,
	PORT_OperationObj,
	PORT_ShowCommandList,
	PORT_ShowCheatList,
	PORT_ShowTime,
#ifdef KAILLERA
	PORT_KailleraChatOpen,
	PORT_KailleraChatMove,
#endif
	PORT_UIUp,
	PORT_UIDown,
	PORT_UILeft,
	PORT_UIRight,
	PORT_UISelect,
	PORT_UICancel,
	PORT_Coin1,
	PORT_Coin2,
	PORT_Coin3,
	PORT_P1Start,
	PORT_P1Select,
	PORT_P1Up,
	PORT_P1Down,
	PORT_P1Left,
	PORT_P1Right,
	PORT_P1ButtonA,
	PORT_P1ButtonB,
	PORT_P1ButtonC,
	PORT_P1ButtonD,
	PORT_P1Custom1,
	PORT_P1Custom2,
	PORT_P1Custom3,
	PORT_P1Custom4,
	PORT_P1TrackYUp,
	PORT_P1TrackYDown,
	PORT_P1TrackXLeft,
	PORT_P1TrackXRight,
	PORT_P2Start,
	PORT_P2Select,
	PORT_P2Up,
	PORT_P2Down,
	PORT_P2Left,
	PORT_P2Right,
	PORT_P2ButtonA,
	PORT_P2ButtonB,
	PORT_P2ButtonC,
	PORT_P2ButtonD,
	PORT_P2Custom1,
	PORT_P2Custom2,
	PORT_P2Custom3,
	PORT_P2Custom4,
	PORT_P2TrackYUp,
	PORT_P2TrackYDown,
	PORT_P2TrackXLeft,
	PORT_P2TrackXRight,
	PORT_Unknown,

	/* NeoGeo Input Port */
	PORT_TestSwitch,
	PORT_CoinChutes,
	PORT_Autofire,
	PORT_CommSetting,
	PORT_FreePlay,
	PORT_Freeze,
	PORT_Territory,
	PORT_MachineMode,
	PORT_Off,
	PORT_On,
	PORT_Japan,
	PORT_USA,
	PORT_Europe,
	PORT_Home,
	PORT_Arcade,

	PORT_last_entry
};

extern char portname[PORT_last_entry + 1][MAX_PORT_LEN + 1];
extern char keyname[KEY_last_entry + 1][MAX_KEY_LEN + 1];

const char *ui_getstring (int string_num);
void keyname_init (void);
void portname_init (void);

#define portname(n) portname[PORT_##n]
#define keyname(n) keyname[KEY_##n]

#endif

